package com.zt.plat.module.qms.iot.tcpserver;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.util.ObjectUtils;
import tech.zzjc.tio.core.ChannelContext;
import tech.zzjc.tio.core.Tio;

import java.math.BigInteger;
import java.nio.charset.Charset;

/**
 * <b>IotUtils</b>
 * <p>
 * 更新历史：
 * <pre> 版本         更新时间            更新者        更新内容<hr/>
 * V1.0      2019年9月27日          王兴荣         Add</pre>
 * <b>Copyright (C)  云南志者竟成科技有限公司</b> 
 * <p>
 * @author 王兴荣 &lt;xingrong_wang@will-way.cn&gt;
 * @version V1.0 
 * @since 2019年9月27日
 */
@Slf4j
public class IotUtils {

    /**
     * 回复客户端心跳
     * @param channelContext
     */
    public static void replyHeartbeat(ChannelContext channelContext) {
        IotPacket resppacket = new IotPacket();
        resppacket.setBody((IotPacket.PONG + "\r\n").getBytes(Charset.forName(IotPacket.CHARSET)));
        Tio.send(channelContext, resppacket);
        log.debug(channelContext.getClientNode().getIp() + ":" + channelContext.getClientNode().getPort() +": 心跳消息。。。。");
    }
    

    /**
     * hex转byte数组
     * @param hex
     * @return
     */
    public static byte[] hexToByte(String hex){
        int m = 0, n = 0;
        int byteLen = hex.length() / 2; // 每两个字符描述一个字节
        byte[] ret = new byte[byteLen];
        for (int i = 0; i < byteLen; i++) {
            m = i * 2 + 1;
            n = m + 1;
            int intVal = Integer.decode("0x" + hex.substring(i * 2, m) + hex.substring(m, n));
            ret[i] = Byte.valueOf((byte)intVal);
        }
        return ret;
    }
    
    public static String bytesToHex(byte[] data) {
        StringBuilder sb = new StringBuilder();
        for (int n = 0; n < data.length; n++) {
            sb.append(StringUtils.leftPad(Integer.toHexString(data[n] & 0xFF), 2, "0")); // 每个字节由两个字符表示，位数不够，高位补0
        }
        return sb.toString();
    }

    public static String transDeviceCodeToId(String deviceCode){
        if(ObjectUtils.isEmpty(deviceCode))
            return "";
        return new BigInteger(deviceCode, Character.MAX_RADIX).toString();
    }

    public static String transDeviceIdToCode(String deviceId){
        if(ObjectUtils.isEmpty(deviceId))
            return "";
        return new BigInteger(deviceId).toString(Character.MAX_RADIX);
    }
}
